#!/usr/local/bin/perl -w
# make_pkts.pl
#

use NF2::PacketGen;
use NF2::PacketLib;
use NF21RouterLib;
require "reg_defines.ph";
$delay = '@4us';
$batch = 0;
nf_set_environment( { PORT_MODE => 'PHYSICAL', MAX_PORTS => 4 } );

# use strict AFTER the $delay, $batch and %reg are declared
use strict;
use vars qw($delay $batch %reg);

# Prepare the DMA and enable interrupts
prepare_DMA('@3.9us');
enable_interrupts(0);

my $length = 1500;
my $DA_sub = ':dd:dd:dd';
my $SA_sub = ':55:55:55:55';
my $DA;
my $SA;
my $pkt;
my $in_port;
my $out_port;
my $temp_source;
my $temp_dest;
my $tresh_hold = 30;

$delay = 17000;
my $time=0;
my $i = 1;
my $i_dest=1;
while ($delay<4000000){

  $temp_source = sprintf("%02x:%02x", ($i_dest>>8)&0xff, $i_dest&0xff);
  $temp_dest = sprintf("60:%02x:%02x", ($i>>8)&0xff, $i&0xff);
  $i_dest = $i_dest+1; 
  $DA = $temp_dest . $DA_sub;
  $SA = $temp_source . $SA_sub;
  $in_port = $i;
  $pkt = make_IP_pkt($length, $DA, $SA, 64, '192.168.0.1', '192.168.0.2');
  nf_packet_in($in_port, $length, 12192, $batch,  $pkt);

  $delay=$delay+12192*2;

}


$delay = 17000;
my $time=0;
my $i = 2;
my $i_dest=1;
while ($delay<4000000){

  $temp_source = sprintf("%02x:%02x", ($i_dest>>8)&0xff, $i_dest&0xff);
  $temp_dest = sprintf("00:%02x:%02x", ($i>>8)&0xff, $i&0xff);
  $i_dest = $i_dest+1; 
  $DA = $temp_dest . $DA_sub;
  $SA = $temp_source . $SA_sub;
  $in_port = $i;
  $pkt = make_IP_pkt($length, $DA, $SA, 64, '192.168.0.1', '192.168.0.2');
  nf_packet_in($in_port, $length, 12192, $batch,  $pkt);
  $delay=$delay+12192*2;
#	$time=$delay;
  #$delay=$delay+int(rand(28448))+12192;

}



# *********** Finishing Up - need this in all scripts ! ****************************
my $t = nf_write_sim_files();
print  "--- make_pkts.pl: Generated all configuration packets.\n";
printf "--- make_pkts.pl: Last packet enters system at approx %0d microseconds.\n",($t/1000);
if (nf_write_expected_files()) {
  die "Unable to write expected files\n";
}

nf_create_hardware_file('LITTLE_ENDIAN');
nf_write_hardware_file('LITTLE_ENDIAN');
